/* dsp32c load - Sample program to download and run a program into the DSP32C
 * Software Development card.
 *
 * Last change: 7/31/89   V 0.2
*/
#include <stdio.h>
#include "coff.h"
#include "dsp32cds.h"


main( int argc, char *argv[])
{
    char *s;
    unsigned short addr;

    while (--argc > 0 && (s = *++argv)[0] == '-') {
        switch(*++s) {
            case 'b':
                if ( *(s+1) != '\0')
                    sscanf(++s,"%i",&addr);
                else {
                    if (--argc < 1) {
                        fprintf(stderr,"no addess specified\n");
                        exit(1);
                    }
                    sscanf(*++argv,"%i",&addr);
                }
                set_base(addr);
                break;
            default:
                fprintf(stderr,"Invalid option %c\n",*s);
                exit(1);
            }
    }
    if ( argc < 1 ) {
        fprintf(stderr,"usage: d3load [-b addr] filename\n");
        exit(1);
    }

    if (init_card() != 0 )
        exit(1);
    if (load_dsp(*argv) != 0 ) {
        fprintf(stderr,"Load of executable %s failed\n",*argv);
        exit(1);
    }
    codec_on();
    run_dsp();
    exit(0);
}
